let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  shell = "/nix/store/drnnv1km6bmfhbli803q7m33rphqwh00-bash-4.4-p23/bin/bash";
  coreutils = "/nix/store/5n9l9nr1jmbcgxd6hq29h1fvdzi11fdi-coreutils-8.32/bin";
  bzip2 = "/nix/store/rzwig6jc4bbxjbc3c7b9qd48s1x8g2yf-bzip2-1.0.6.0.2-bin/bin/bzip2";
  gzip = "/nix/store/9n3l0yf9pswjipdyaw8mgi2swbjjbzmk-gzip-1.10/bin/gzip";
  xz = "/nix/store/b63b1vqr6p7ck83kcy6ahjinyskbsvqa-xz-5.2.5-bin/bin/xz";
  tar = "/nix/store/hzk3a4r501mymqzw6dqgxpa381s7lhc2-gnutar-1.34/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/5n9l9nr1jmbcgxd6hq29h1fvdzi11fdi-coreutils-8.32/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/bsf2k9lw03j9q5w885v4xkv4w7ig9xdi-nix-2.3.17/bin";
  nixPrefix = "/nix/store/bsf2k9lw03j9q5w885v4xkv4w7ig9xdi-nix-2.3.17";
  nixLibexecDir = fromEnv "NIX_LIBEXEC_DIR" "/nix/store/bsf2k9lw03j9q5w885v4xkv4w7ig9xdi-nix-2.3.17/libexec";
  nixLocalstateDir = "/nix/var";
  nixSysconfDir = "/etc";
  nixStoreDir = fromEnv "NIX_STORE_DIR" "/nix/store";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
